#############################
#
# COPYRIGHT (c) 2007 shagon
# FILENAME:Snake_01.py
# COMPILER:PythonWin
# DEBUG ON Series 60 C++ SDKs
# TESTED ON MY NOKIA6670
# DATE:Sep 20th,2007
#
##############################
# -*- coding:utf-8 -*- 
import appuifw
import math
import e32
from key_codes import *
from graphics import *
import random
appuifw.app.screen='large' 
appuifw.app.title='随心所欲'.decode("utf-8")
appuifw.app.body = appuifw.Text('\n\n\n\n     随心所欲(shagon出品)\n “贪吃蛇”系列之Snake_01 \n－－－－－－－－－－－－－\n点击左软键呼出菜单\n点击右软建退出游戏'.decode("utf-8"))
def exit_key_handler():
    app_lock.signal()   
init_game_size=5
init_back_red=192
init_back_green=192
init_back_blue=128
init_snake_red=0
init_snake_green=128
init_snake_blue=0
init_food_red=255
init_food_green=0
init_food_blue=0
init_speed=0.08
init_score_add=10
init_lenth_add=10
class SnakeGame:
    global init_game_size,init_back_red,init_back_green,init_back_blue,init_snake_red,init_snake_green,init_snake_blue,init_food_red,init_food_green,init_food_blue,init_speed,init_score_add,init_lenth_add
    deltas=((1,0),(0,-1),(-1,0),(0,1))
    def __init__(self):
        self.direction=0
        self.step=init_game_size
        self.color=(init_snake_red,init_snake_green,init_snake_blue)
        self.fillarray={}
        self.exitflag=0
        self.score=0
        self.wormlocs=[]
        self.wormlength=10
        self.foodloc=None
        self.fieldcolor=(init_back_red,init_back_green,init_back_blue)
        self.resboxoffset=2        
        self.state='init'        
        self.old_body=appuifw.app.body
        self.canvas=appuifw.Canvas(redraw_callback=self.redraw)
        self.draw=Draw(self.canvas)
        appuifw.app.body=self.canvas
        self.fieldsize=(self.canvas.size[0]/self.step,(self.canvas.size[1]-16)/self.step)        
        self.canvas.bind(EKeyRightArrow,lambda:self.turnto(0))
        self.canvas.bind(EKeyUpArrow,lambda:self.turnto(1))
        self.canvas.bind(EKeyLeftArrow,lambda:self.turnto(2))
        self.canvas.bind(EKeyDownArrow,lambda:self.turnto(3))
        self.loc=[self.fieldsize[0]/2,self.fieldsize[1]/2]        
        self.place_food()
        self.state='playing'
        self.redraw(())
    def turnto(self,direction):
        self.direction=direction
    def close_canvas(self):
        appuifw.app.body=self.old_body
        self.canvas=None
        self.draw=None
        appuifw.app.exit_key_handler=None
    def redraw(self,rect):
        self.draw.clear(self.fieldcolor)
        for loc in self.fillarray.keys():
            self.draw_square(loc,self.color)
        self.draw_score()
        if self.foodloc:
            self.draw_food()        
    def draw_square(self,loc,color):
        self.draw.rectangle((loc[0]*self.step,
                             16+loc[1]*self.step,
                             loc[0]*self.step+self.step,
                             16+loc[1]*self.step+self.step),fill=color)
    def draw_score(self):
        scoretext='得分：%d'.decode("utf-8")%self.score
        textrect=self.draw.measure_text(scoretext, font='title')[0]
        self.draw.rectangle((0,0,textrect[2]-textrect[0]+self.resboxoffset,
                             textrect[3]-textrect[1]+self.resboxoffset),fill=(0,0,0))      
        self.draw.text((-textrect[0],-textrect[1]),scoretext,(0,192,0),"title")
    def draw_food(self):
        self.draw_square(self.foodloc,(255,0,0))        
    def place_food(self):
        while 1:
            self.foodloc=(random.randint(0,self.fieldsize[0]-1),
                          random.randint(0,self.fieldsize[1]-1))
            if not self.fillarray.has_key(self.foodloc): break
        self.draw_food()
    def set_exit(self):
        self.exitflag=1
    def run(self):
        appuifw.app.exit_key_handler=self.set_exit
        while not self.exitflag:
            self.draw_square(self.loc,self.color)
            if (tuple(self.loc) in self.fillarray or
                self.loc[0]>=self.fieldsize[0] or self.loc[0]<0 or
                self.loc[1]>=self.fieldsize[1] or self.loc[1]<0):
                break
            if tuple(self.loc)==self.foodloc:
                self.score+=init_score_add
                self.draw_score()
                self.place_food()
                self.draw_food()
                self.wormlength+=init_lenth_add
            if len(self.wormlocs)>self.wormlength:
                loc=self.wormlocs[0]
                del self.wormlocs[0]
                del self.fillarray[loc]
                self.draw_square(loc,self.fieldcolor)
            self.fillarray[tuple(self.loc)]=1
            self.wormlocs.append(tuple(self.loc))
            e32.ao_sleep(init_speed)
            self.loc[0]+=self.deltas[self.direction][0]
            self.loc[1]+=self.deltas[self.direction][1]
        self.close_canvas()

def game_start():
    appuifw.app.screen='full'
    playing=1
    while playing:
        game=SnakeGame()
        game.run()
        playing=appuifw.query('最后得分：%d \n 再玩一局？'.decode("utf-8")%game.score,'query')  
        
def wenter():
    appuifw.note('输入错误'.decode("utf-8"),"error")
def renter():
    appuifw.note('设定成功'.decode("utf-8"), "conf")
        
def game_size():
    global init_game_size
    while 1:
        init_game_size=appuifw.query('设置图形大小 \n初始为5'.decode("utf-8"),'number')
        if init_game_size<=0: wenter()
        else:
            renter()
            break

def color_set(): 
    global init_back_red,init_back_green,init_back_blue,init_snake_red,init_snake_green,init_snake_blue,init_food_red,init_food_green,init_food_blue
    color_set_choice =['背景色'.decode("utf-8"), '贪吃蛇'.decode("utf-8"),'食物色'.decode("utf-8")]
    index=appuifw.selection_list(choices=color_set_choice , search_field=1)
    if index==0:
        while 1:
            init_back_red=appuifw.query('设定红色素值（0－255）\n初始为192'.decode("utf-8"),'number')
            if init_back_red<0 or init_back_red>255: wenter()
            else: break
        while 1:
            init_back_green=appuifw.query('设定绿色素值（0－255）\n初始为192'.decode("utf-8"),'number')
            if init_back_green<0 or init_back_green>255: wenter()
            else: break
        while 1:
            init_back_blue=appuifw.query('设定蓝色素值（0－255）\n初始为128'.decode("utf-8"),'number')
            if init_back_blue<0 or init_back_blue>255: wenter()
            else: break
        renter()            
    elif index==1:
        while 1:
            init_snake_red=appuifw.query('设定红色素值（0－255）\n初始为0'.decode("utf-8"),'number')
            if init_snake_red<0 or init_snake_red>255: wenter()
            else: break
        while 1:
            init_snake_green=appuifw.query('设定绿色素值（0－255）\n初始为128'.decode("utf-8"),'number')
            if init_snake_green<0 or init_snake_green>255: wenter()
            else: break
        while 1:
            init_snake_blue=appuifw.query('设定蓝色素值（0－255）\n初始为0'.decode("utf-8"),'number')
            if init_snake_blue<0 or init_snake_blue>255: wenter()
            else: break
        renter()            
    else:
        while 1:
            init_food_red=appuifw.query('设定红色素值（0－255）\n初始为255'.decode("utf-8"),'number')
            if init_food_red<0 or init_food_red>255: wenter()
            else: break
        while 1:
            init_food_green=appuifw.query('设定绿色素值（0－255）\n初始为0'.decode("utf-8"),'number')
            if init_food_green<0 or init_food_green>255: wenter()
            else: break
        while 1:
            init_food_blue=appuifw.query('设定蓝色素值（0－255）\n初始为0'.decode("utf-8"),'number')
            if init_food_blue<0 or init_food_blue>255: wenter()
            else: break
        renter()

    
def game_speed():
    global init_speed
    while 1:
        init_speed=appuifw.query('设置速度\n初始为12'.decode("utf-8"),'number')
        if init_speed<=0.0: wenter()            
        else:
            init_speed=1.0/init_speed
            renter()
            break
    
def add_set():
    global init_score_add,init_lenth_add
    add_set_choice =['加分增量'.decode("utf-8"), '蛇身增量'.decode("utf-8")]
    index=appuifw.selection_list(choices=add_set_choice , search_field=1)
    if index==0:
        while 1:
            init_score_add=appuifw.query('设置加分增量\n初始为10'.decode("utf-8"),'number')
            if init_score_add<=0: wenter()
            else:
                renter()
                break
    else:
        while 1:
            init_lenth_add=appuifw.query('设置蛇身增量\n初始为10'.decode("utf-8"),'number')
            if init_lenth_add<=0: wenter()
            else:
                renter()
                break


def about_info():
    appuifw.note('杜俊(shagon)作品 \n www.cnpda.com.cn \n 2007.09.20'.decode("utf-8"), "info")
def history_info():
    appuifw.note('07.09.21\n修正两处错误\n07.09.20\n首发'.decode("utf-8"), "info")  
def game_exit():
    appuifw.app.set_exit()
    
appuifw.app.menu =[
                    (
                      ('用户设定'.decode("utf-8")),
                      (
                          ('大小'.decode("utf-8"),game_size),
                          ('颜色'.decode("utf-8"),color_set),
                          ('速度'.decode("utf-8"),game_speed),
                          ('增量'.decode("utf-8"),add_set)
                                                               )),
                                                                                 
                      ('开始游戏'.decode("utf-8"),game_start),
                      ('关于作者'.decode("utf-8"),about_info),
                      ('历史更新'.decode("utf-8"),history_info),
                      ('退出游戏'.decode("utf-8"),game_exit)
                                                                                       ]                                                        
                    

app_lock = e32.Ao_lock()
app_lock.wait()